
#ifndef GTIME_H
#define GTIME_H

#define GAMETIMER_FREQUENCY 1000

#define GTIME_NORMAL 0
#define GTIME_FAST   1

#define GTIME_OK                       0
#define GTIME_ERROR_OUT_OF_MEMORY      1
#define GTIME_ERROR_NULL_ARGUMENT      2
#define GTIME_ERROR_NOT_INSTALLED      3
#define GTIME_ERROR_ALREADY_INSTALLED  4
#define GTIME_MAX_ERRORS               5


#ifdef __cplusplus
extern "C" {
#endif

extern volatile int GameTime;

void GTIME_Remove(void);
int GTIME_Install();
int GTIME_AddFunction(int (*func)(void*), int period, void *data, int mode);
int GTIME_RemoveFunction(int (*func)(void*), void *data);
int GTIME_Reset();
int GTIME_Poll();
int GTIME_FreezeTimer();
int GTIME_UnFreezeTimer();
int GTIME_IsFrozen();


#ifdef __cplusplus
}
#endif


#endif
