typedef struct INPUT {
	int InputType;
	void *InputData;
} INPUT;

#define INPUT_TYPE_KEYBOARD 1
#define INPUT_TYPE_MOUSE    2
#define INPUT_TYPE_JOYSTICK 3
#define INPUT_TYPE_MAX      4

typedef struct INPUT_KEYB {
	int Up, Down, Right, Left;
	int Fire;
} INPUT_KEYB;

typedef struct INPUT_MOUSE {
	int *x_axis, *y_axis;
	int fireb;
} INPUT_MOUSE;

typedef struct INPUT_JOY {
	int JoystickNum;
	int UpAxis, DownAxis, RightAxis, LeftAxis;
	int UpStick, DownStick, RightStick, LeftStick;
	int Fire;
} INPUT_JOY;

#define INPUT_KEY_UP    0x00000001
#define INPUT_KEY_DOWN  0x00000002
#define INPUT_KEY_RIGHT 0x00000004
#define INPUT_KEY_LEFT  0x00000008
#define INPUT_KEY_FIRE  0x00000010

extern int get_input(INPUT *dev, int key);
extern INPUT *create_input(int dev);
extern void destroy_input(INPUT ** in);

extern int get_input_type(INPUT *dev);
extern char* get_input_type_name(INPUT *dev);
extern char* get_input_type_full_name(INPUT *dev);

extern const char *get_input_name(INPUT *dev, int control, char *buf, int length);
extern int set_input(INPUT *dev, int control, const char *k);

extern void set_input_key(INPUT *dev, int control, int k);
extern void set_input_joy(INPUT *dev, int control, int jn, int sn, int an);

extern int get_input_key(INPUT *dev, int control);
extern int get_input_joy_button(INPUT *dev, int control);
extern int get_input_joy_stick(INPUT *dev, int control);
extern int get_input_joy_axis(INPUT *dev, int control);
