#ifndef LOG_H
#define LOG_H

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif
extern void Log(const char *format, ...);

extern int LogIndent;

#ifdef DJGPP
#define LOGINFO          __FILE__, __FUNCTION__, __LINE__
#else
#define LOGINFO          __FILE__, "", __LINE__
#endif

#ifdef ERROR
#undef ERROR
#endif

#ifdef DEBUGMODE


#define LOG Log

#define LOGFUNCSTART() { \
	LOG("%s.%li {\n", LOGINFO); \
	LogIndent++; \
	}

#define LOGFUNCEND() { \
	 LogIndent--;  \
	LOG("}"); \
	}

#define ERROR(n, x) {                     \
	sprintf(Error, ErrorString[n], x);    \
	LOG("%s.%i  %s\n", __FILE__, __LINE__, Error); \
	return n;                             \
}
#define ERROR2(n, x, y) {                    \
	sprintf(Error, ErrorString[n], x, y);    \
	LOG("%s.%i  %s\n", __FILE__, __LINE__, Error); \
}
#define VERROR(n, x) {                     \
	sprintf(Error, ErrorString[n], x);    \
	LOG("%s.%i  %s\n", __FILE__, __LINE__, Error); \
	return;                             \
}

#else


#define ERROR(n, x)
#define ERROR2(n, x, y)
#define VERROR(n, x)
#define LOG(format, arg...)

#endif



//#ifndef LOGFILE 
#define LOGFILE "log.txt"
//#endif

extern char Error[256];


#ifdef __cplusplus
}
#endif


#endif

