/* gfx.c - graphics init module
 * 
 * Copyright 2001 by Robert J Ohannessian.
 *
 * This code is placed under the GNU General Public License.
 * Please refer to the accompanying file 'copying.txt' for details.
 */

#include "allegro.h"
#include "gfx.h"


BITMAP *BackBuffer = NULL;
int display_w = 640;
int display_h = 480;
int fullscreen = 1;


int GFX_Init(void)
{
	set_color_depth(8);
	if (set_gfx_mode(fullscreen?
			GFX_AUTODETECT_FULLSCREEN:GFX_AUTODETECT_WINDOWED,
			display_w, display_h, 0, 0)) {
		allegro_message("Can't set graphics mode!\n");
		return -1;
	}

	return 0;
}



int GFX_Shutdown() {

	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);

	BackBuffer = NULL;

	return 0;
}	


BITMAP *GFX_CreateAccelBitmap(int w, int h) {

	BITMAP *ret = NULL;
/*
	if (gfx_capabilities & GFX_HW_VRAM_BLIT)
		ret = create_video_bitmap(w, h);
*/
	if (!ret && (gfx_capabilities & GFX_HW_SYS_TO_VRAM_BLIT))
		ret = create_system_bitmap(w, h);

	if (!ret)
		ret = create_bitmap(w, h);

	return ret;
}

BITMAP *GFX_CreateAccelMaskedBitmap(int w, int h) {

	BITMAP *ret = NULL;	
/*
	if (gfx_capabilities & GFX_HW_VRAM_BLIT_MASKED)
		ret = create_video_bitmap(w, h);

	if (!ret && (gfx_capabilities & GFX_HW_SYS_TO_VRAM_BLIT_MASKED))
		ret = create_system_bitmap(w, h);
*/
	if (!ret)
		ret = create_bitmap(w, h);

	return ret;
}

void GFX_HQ_RotateSprite(BITMAP *dest, BITMAP *src, int x, int y, fixed angle) {

	BITMAP *temp1 = create_bitmap(src->w * 2,  src->h * 2);

	stretch_blit(src, temp1, 0, 0, src->w, src->h, 0, 0, temp1->w, temp1->h);
	rotate_scaled_sprite(dest, temp1, x, y, angle, ftofix(0.5));

	destroy_bitmap(temp1);

	return;
}


