/* log.c - Log module
 * 
 * This is public domain. Do whatever you like.
 *
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "log.h"


static char indent[70];
char Error[256];
int LogIndent = 0;

void Log(const char *format, ...) {
	va_list args;
	FILE *f;

	va_start(args, format);
	f = fopen(LOGFILE,"at+");

	if (LogIndent < 0) LogIndent = 0;
	if (LogIndent > 64) LogIndent = 64;
	memset(indent, '\t', LogIndent);
	indent[LogIndent] = 0;

	fprintf(f, "%s", indent);
	vfprintf(f, format, args);

	fflush(f);
	fclose(f);
	va_end(args);

}
